"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
exports.defaultOpts = void 0;

var _helperModuleImports = require("@babel/helper-module-imports");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const defaultOpts = {
  nameHint: '_babel_plugin_jsx_classnames_advanced',
  attributeNames: ['className', 'dropdownClassName', 'wrapperClassName', 'wrapClassName', 'overlayClassName'],
  ignoreMemberExpression: true,
  ignoreIdentifier: true
};
exports.defaultOpts = defaultOpts;

function _default({
  types: t
}) {
  function replaceNode(path, callee) {
    path.node.value = t.JSXExpressionContainer(t.callExpression(callee, [path.node.value.expression]));
  }

  const visitor = {
    JSXAttribute(path, state) {
      const {
        attributeNames,
        nameHint,
        ignoreIdentifier,
        ignoreMemberExpression
      } = _objectSpread({}, defaultOpts, state.opts);

      if (!attributeNames.some(i => t.isJSXIdentifier(path.node.name, {
        name: i
      })) || !t.isJSXExpressionContainer(path.node.value) || t.isStringLiteral(path.node.value.expression) || t.isMemberExpression(path.node.value.expression) && ignoreMemberExpression || t.isIdentifier(path.node.value.expression) && ignoreIdentifier) return;

      if (nameHint === false) {
        replaceNode(path, (0, _helperModuleImports.addDefault)(path, 'classnames', {
          nameHint: defaultOpts.nameHint
        }));
        return;
      }

      if (!state.isImported) {
        state.importedIndentifier = (0, _helperModuleImports.addDefault)(path, 'classnames', {
          nameHint
        });
        replaceNode(path, state.importedIndentifier);
        state.isImported = 1;
      } else {
        replaceNode(path, t.identifier(state.importedIndentifier.name));
      }
    }

  };
  return {
    visitor
  };
}
//# sourceMappingURL=index.js.map